SynapseRTTestPlansIssuePanel = function(tableId, paginatorId, toolbarId, errorDivId, issueKey, panelType, projectKey){
	this.tableId = tableId;
	this.paginatorId = paginatorId;
	this.issueKey = issueKey;
	this.projectKey = projectKey;
	this.startIndex = 0;
	this.panelType = panelType;
	this.pages;
	this.customDesign;
	this.currentPage = 1;
	this.issues;
	this.submodels;
	this.fields;
	this.pager;
	this.orderType;
	this.orderBy;
	this.stateColors;
	//Must be set to color rows according to state
	this.coloredRows = true;
	this.coloredRowsFieldId;
	//Must be set to add statistics according to state
	this.statistics;
	this.totalTitle;
	this.statisticsTitle;
	//Must be set in order to allow toolbar in given element
	this.toolbarId = toolbarId;
	//Available filters stored here
	this.filters;
	//User-choosen filters stored here
	this.selectedFilters={};
	//numberToLoadInput element on page, keeps actual load limit
	this.numberToLoadInput;
	//keeps issue load limit to display it in the numberToLoadInput when rebuilding toolbar
	this.numberToLoad;
	
	//keeps progress, name of current issue operation
	this.operation;
	//manages which operation button will be displayed
    this.actions;
	
	this.init = function(){
		this.currentPage = 1;
		this.startIndex = 0;
		//init toolbar
		this.reloadToolbar();
		//statistics is loaded only once, generating less load on the server
		this.reloadStats();
		this.reloadOperations();
		this.reload();
	}
	
	this.reload = function(){
		var data = 'issueKey='+this.issueKey+'&startIndex=' + this.startIndex 
				+ '&panelType=' + this.panelType;
		if(this.orderType && this.orderBy)
				data += '&orderType=' + this.orderType + '&orderBy=' + this.orderBy;
		if(this.selectedFilters){
			for(var filter in this.selectedFilters){
				data+='&' + filter + '=' + this.selectedFilters[filter];
			}
		}
		if(this.projectKey){
			data += '&projectKey=' + this.projectKey;
		}
		
		if(this.numberToLoadInput && this.numberToLoadInput.val()){
			data+='&limit='+this.numberToLoadInput.val();
		}
        console.log('loading tc panel: ' + data);
        AJS.$.ajax({
            url: AJS.contextPath() + '/plugins/servlet/customizableTestPlanPanelServlet',
            async: false,
            type: 'POST',
            data: data,
            panel: this,
            success: function(result) {
            	console.log('got result: ' + result);
                var obj = JSON.parse(result);

                if (obj.errors) {
                    var errorMsg = AJS.$('#' + errorDivId);
                    errorMsg.empty();
                    if(obj.errors.length > 0) {
                        for(var i = 0; i < obj.errors.length; i++) {
                            AJS.messages.error('#' + errorDivId, {
							   title:obj.errors[i]
							});
                        }
                        errorMsg.show();
                    }
                }

                if (obj.pages && parseInt(obj.pages, 10) > 0) {
                	this.panel.pages = obj.pages;
                }else
                	this.panel.pages = null;
									
                if(obj.issues) {
                	this.panel.issues = obj.issues;
                }else
                	this.panel.issues = null;
                	 
                if(obj.isSubTest) {
                	this.panel.isSubTest = obj.isSubTest;
                }else
                	this.panel.isSubTest = null;
                	
                if(obj.fields) {
                	this.panel.fields = obj.fields;
                }else
                	this.panel.fields = null;
                
                if(obj.submodels){
                	this.panel.submodels = obj.submodels;
                }else
                	this.panel.submodels = null;
                
                if(obj.stateColors){
                	this.panel.stateColors = obj.stateColors;
                }else
                	this.panel.stateColors = null;
                
                if(obj.coloredRowsFieldId){
                	this.panel.coloredRowsFieldId = obj.coloredRowsFieldId;
                }else
                	this.panel.coloredRowsFieldId = null;
                
                if(obj.customDesign){
                	this.panel.customDesign = obj.customDesign;
                }else
                	this.panel.customDesign = null;
                
                this.panel.rebuild();
            }
        });
	}
	
	this.reloadStats = function(){
		var data = 'issueKey='+this.issueKey+'&startIndex=' + this.startIndex 
				+ '&panelType=' + this.panelType + '&action=stats';
		if(this.orderType && this.orderBy)
				data += '&orderType=' + this.orderType + '&orderBy=' + this.orderBy;
        console.log('loading tc panel: ' + data);
        AJS.$.ajax({
            url: AJS.contextPath() + '/plugins/servlet/customizableTestPlanPanelServlet',
            async: false,
            type: 'POST',
            data: data,
            panel: this,
            success: function(result) {
            	console.log('got result: ' + result);
                var obj = JSON.parse(result);

                if (obj.errors) {
                    var tcErrorMsg = AJS.$('#tcErrorMsg')
                    if(obj.errors.length > 0) {
                        for(var i = 0; i < obj.errors.length; i++) {
                            tcErrorMsg.append(AJS.$('<p/>').text(obj.errors[i]));
                        }

                        tcErrorMsg.show();
                    } else {
                        tcErrorMsg.hide();
                    }
                }
                
                if(obj.stateColors){
                	this.panel.stateColors = obj.stateColors;
                }else
                	this.panel.stateColors = null;
                
                if(obj.statistics){
                	this.panel.statistics = obj.statistics;
                }else
                	this.panel.statistics = null;
                
                if(obj.totalTitle){
                	this.panel.totalTitle = obj.totalTitle;
                }else
                	this.panel.totalTitle = null;
                
                if(obj.statisticsTitle){
                	this.panel.statisticsTitle = obj.statisticsTitle;
                }else
                	this.panel.statisticsTitle = null;
            }
        });
	}
	
	this.reloadToolbar = function(){
		var data = 'issueKey='+this.issueKey+'&startIndex=' + this.startIndex 
				+ '&panelType=' + this.panelType + '&action=filters';
		if(this.orderType && this.orderBy)
				data += '&orderType=' + this.orderType + '&orderBy=' + this.orderBy;
        console.log('loading tc panel: ' + data);
        AJS.$.ajax({
            url: AJS.contextPath() + '/plugins/servlet/customizableTestPlanPanelServlet',
            async: false,
            type: 'POST',
            data: data,
            panel: this,
            success: function(result) {
            	console.log('got result: ' + result);
                var obj = JSON.parse(result);

                if (obj.errors) {
                    var tcErrorMsg = AJS.$('#tcErrorMsg')
                    if(obj.errors.length > 0) {
                        for(var i = 0; i < obj.errors.length; i++) {
                            tcErrorMsg.append(AJS.$('<p/>').text(obj.errors[i]));
                        }

                        tcErrorMsg.show();
                    } else {
                        tcErrorMsg.hide();
                    }
                }
                
                if(obj.filters){
                	this.panel.filters = obj.filters;
                }else
                	this.panel.filters = null;
                
                if(obj.limit){
                	this.panel.numberToLoad = obj.limit;
                }else
                	this.panel.numberToLoad = null;
                
                this.panel.rebuildToolbar();
            }
        });
	}
	
	
	this.reloadOperations = function(){
		var data = 'issueKey='+this.issueKey
				+ '&panelType=' + this.panelType + '&action=operations';
        console.log('loading tc panel: ' + data);
        AJS.$.ajax({
            url: AJS.contextPath() + '/plugins/servlet/customizableTestPlanPanelServlet',
            async: false,
            type: 'POST',
            data: data,
            panel: this,
            success: function(result) {
            	console.log('got result: ' + result);
                var obj = JSON.parse(result);

                if (obj.errors) {
                    var tcErrorMsg = AJS.$('#tcErrorMsg')
                    if(obj.errors.length > 0) {
                        for(var i = 0; i < obj.errors.length; i++) {
                            tcErrorMsg.append(AJS.$('<p/>').text(obj.errors[i]));
                        }

                        tcErrorMsg.show();
                    } else {
                        tcErrorMsg.hide();
                    }
                }
                
                if(obj.operation){
                	this.panel.operation = obj.operation;
                }else
                	this.panel.operation = null;
                
                if(obj.actions){
                	this.panel.actions = obj.actions;
                }else
                	this.panel.actions = null;
                	
                if(obj.messages){
                	this.panel.messages = obj.messages;
                }else
                	this.panel.messages = null;
            }
        });
	}
	
	this.rebuild = function(){
		var tableId = this.tableId;
		console.log('rebuild panel ' + tableId);
		var table = AJS.$('#' + tableId);
		var issues = this.issues;
		var fields = this.fields;
		//store statistics on states
		var statisticsMap = {};
		table.empty();
		
		
        if(this.statistics){
        	var statistics = this.statistics;
	        var statisticsTable = AJS.$('<table/>',{'class':'synapse-issuepanel-statistics-table'});
	        //Add statistics
	        var totalStates = 0;
	        for(var state in statistics){
	        	totalStates += statistics[state];
	        }
	        
	        for(var state in this.stateColors){
	        	if(statistics.hasOwnProperty(state)){
	        		var percent = statistics[state]/totalStates*100;
	        		var displayPercent = Math.round(percent*10)/10;
	        		var progressDiv = AJS.$('<div/>',{
	        			'class':'synapse-issuepanel-statistics-progress-bar',
	        			'text':statistics[state]
        			}).css({'width':percent + '%','background-color':this.stateColors[state], 'border-color':this.stateColors[state]});
	        		statisticsTable.append(
	        			AJS.$('<tr/>').append(
	        				AJS.$('<td/>',{'class':'synapse-issuepanel-statistics-table-legend-td'}).append(state + ' - ' + displayPercent + '%'),
	        				AJS.$('<td/>').append(progressDiv)
	        			)
	        		);
	        	}
	        }
	        
	        var statTD = AJS.$('<td/>',{'colspan':fields.length});
	        statTD.append(
	        	statisticsTable,
	        	this.totalTitle + ': ' + totalStates
	    	);
	        table.append(AJS.$('<tr/>').append(
	        	AJS.$('<th/>',{'colspan':fields.length,'text':this.statisticsTitle})
	        ));
	        table.append(AJS.$('<tr/>').append(statTD));
        }
        if(this.actions || this.operation || this.messages){
	        var actionsTD = AJS.$('<td/>',{'colspan':fields.length});
        	if(this.operation){
        		var operation = this.operation;
		        var operationTable = AJS.$('<table/>',{'class':'synapse-issuepanel-statistics-table'});
		        //Add statistics
		        
	    		var progressDiv = AJS.$('<div/>',{
	    			'class':'synapse-issuepanel-statistics-progress-bar',
	    			'text':operation.percent + '%'
				}).css({'width':operation.percent + '%','background-color':'#e1ecf2', 'border-color':'#e1ecf2'});
	    		operationTable.append(
	    			AJS.$('<tr/>').append(
	    				AJS.$('<td/>',{'class':'synapse-issuepanel-statistics-table-legend-td'}).append(operation.name),
	    				AJS.$('<td/>').append(progressDiv)
	    			)
	    		);
		        
		        actionsTD.append(operationTable);
        	}
        	
        	if(this.messages){
        		for(var j = 0; j < this.messages.length; j++){
        			actionsTD.append(this.messages[j] + '<br/>');
        		}
        	}
        	
        	if(this.actions){
	        	for(var j = 0; j < this.actions.length; j++){
	        		var action = this.actions[j];
	        		var buttonClass = 'aui-button';
	        		if(action.minor)
	        			buttonClass += ' aui-button-link';
	        		var actionButton = AJS.$('<button/>', {'class':buttonClass,'text':action.name,'actionId':action.id, 'actionData':action.actionData}).click(
						{
							panel:this
						},
						function(event){
							event.data.panel.executeAction(AJS.$(this).attr('actionId'), AJS.$(this).attr('actionData'));
							event.stopPropagation();
							event.preventDefault();
							event.stopImmediatePropagation();
												}
					);
					actionsTD.append(actionButton);
	        	}
        	}
	        table.append(AJS.$('<tr/>').append(actionsTD));
        }

		//TODO headers should be provided by specific field of servlet's response;
		
		if(fields){
			var headerRow = AJS.$('<tr/>');
	        for (var j = 0; j < fields.length; j++) {
	        	var name="";
	        	if (fields[j].name=="Widget"){
		                	if((this.panelType=="test_plan4tcs_issue_panel")){name="Test Plans";}
		                	else if((this.panelType=="test_plan4tps_issue_panel")&&(this.isSubTest)){
		                		name = "SubTest";}else{name="Test Case";}
	        	}
	        else if (fields[j].name=="Parent"){
	        		
	        		if(this.panelType=="requirement_issue_panel"){name="Parent Requirement"}
                	else if ((this.panelType=="test_case_issue_panel")
                	||(this.panelType=="test_plan4tcs_issue_panel_subtables")
                	||(this.panelType=="defect_coverage_issue_panel")
                	||(this.panelType=="test_plan4tps_issue_panel")
                	){name="Parent Test Case"}
                	else{name="Parent"}
        	}
        	else{
        		name = fields[j].name;
        	}
	        	  	
	        	
	        	var fieldHead = AJS.$('<th/>',{'text':name});
	        	
	        	if(fields[j].id == this.orderBy){
	        		if(this.orderType == 'ASC')
	        			fieldHead.addClass('synapse-sort-asc');
	        		else if(this.orderType == 'DESC')
	        			fieldHead.addClass('synapse-sort-desc');
	        	}
	        	
	        	if(fields[j].orderable == '1'){
	        		fieldHead.attr('fieldId', fields[j].id);
	        		fieldHead.css('cursor','pointer');
	            	fieldHead.click(
						{panel:this},
						function(event){
							event.data.panel.sort(AJS.$(this));
						}
					);
				}
				headerRow.append(fieldHead);
	        }
			table.append(headerRow);
		}
		
		if(!issues || issues.length==0){
			var issueRow = AJS.$('<tr/>');
			var issueTD = AJS.$('<td/>', {
				'colspan':fields.length,
				'text':AJS.I18n.getText('com.go2group.synapse.panel.view.no.issues')
			}).css({'text-align': 'center'});
			issueRow.append(issueTD);
			table.append(issueRow);
		}else{
			
			for (var j = 0; j < issues.length; j++) {
	        	var issue = issues[j];
	        	var issueRow = AJS.$('<tr/>');
	        	
	        	//Coloring issue row according to state

	       	        /*	if(this.coloredRows){
	        		
	        		if(this.coloredRows&&this.coloredRowsFieldId&&(issue[this.coloredRowsFieldId]!="")){
	        	        var colorRowsFieldObj = issue[this.coloredRowsFieldId];
	        	              console.log('   colorRowsFieldObj ' + colorRowsFieldObj);
	        	              if (colorRowsFieldObj!="undefined"){
	        	              if(colorRowsFieldObj.hasOwnProperty('text')){
	        	        var colorRowsFieldVal = colorRowsFieldObj.text;
	        	              console.log('colorRowsFieldVal ' + colorRowsFieldVal);
	        	           issueRow.css({'background-color':this.stateColors[colorRowsFieldVal]});
	        	           }
	        	           }
	        	              
	        	          }
	        		       }*/
          
	            for (var k = 0; k < fields.length; k++) {
	            	console.log('parse field ' + fields[k].id);
	            	var issueTD = AJS.$('<td/>');
	            	if(fields[k].id == 'com.go2group.jira.plugin.synapse.widget'){
	                	var obj = issue[fields[k].id]; 
	                	if(obj){
	                		
	                		if(this.customDesign == "on"){
		                        var divWidgetTable = AJS.$('<div/>', {
		                            'class': 'synapse-tab-widget-table'
		                        });
	                        	
	                        	var divWrapper ="";
								if(obj.status=="Closed"){
									 divWrapper = AJS.$('<div/>', {
										'class': 'synapse-custom-issuepanel-issue-item-wrapper ' + getClassColorKey(obj.status)
									});

								
								}else{
									 divWrapper = AJS.$('<div/>', {
										'class': 'synapse-custom-issuepanel-issue-item-wrapper ' + getClassColorKey(obj.state)
									});		}

								var divWidget = AJS.$('<div/>', {
									'class': 'synapse-custom-cf-issue-item-widget'
								}).css({
									'cursor': 'pointer'
								}).click(
									function(){
										window.open(AJS.contextPath() + '/browse/' + AJS.$(this).text(), '_blank');
									}
								).append(
									obj.key
								);
								
	                            divWidgetTable.append(
	                            	AJS.$('<div/>', {
	                                	'class': 'synapse-tab-widget-cell'
	                            	}).append(
	                            		divWrapper.append(
	                            			divWidget,
											AJS.$('<div/>', {
												'class': 'synapse-cf-issue-item-summary'
											}).append(
												AJS.$('<p/>').text(obj.summary)
											)
	                            		)
	                            	)
	                        	);
	                    		issueTD.append(divWidgetTable);
	                        }else{
		                        var divWidgetTable = AJS.$('<div/>', {
		                            'class': 'synapse-tab-widget-table'
		                        });
		                		var divWidgetKey = AJS.$('<div/>', {
		                           	'class': 'synapse-tab-widget-key',
		                            'click': function() {
		                                window.open(AJS.contextPath() + "/browse/" + AJS.$(this).text(), '_blank');
		                            }
		                        }).text(obj.key).css("background-color", obj.issuetypecolor);
		
		                      
		var divWidgetInfo ="";
if(obj.status=="Closed"){
	   divWidgetInfo = AJS.$('<div/>', {
          'class': 'synapse-tab-widget-info ' + getClassColorKey(obj.status)
      }).text(obj.summary);

}else{
	   divWidgetInfo = AJS.$('<div/>', {
          'class': 'synapse-tab-widget-info ' + getClassColorKey(obj.state)
      }).text(obj.summary);
		}


		                        divWidgetTable.append(
		                        	AJS.$('<div/>', {
		                            	'class': 'synapse-tab-widget-cell'
		                        	}).append(
		                        		AJS.$('<div/>', {
			                                'class': 'synapse-tab-widget',
			                                'title': obj.summary
			                            }).append(
			                            	divWidgetKey,
		                            		divWidgetInfo
		                        		)
		                        	)
		                    	);
	                    		issueTD.append(divWidgetTable);
	                		}
	                	}
	            	}else if(fields[k].id == 'com.go2group.jira.plugin.synapse.fisheye'){
	                	var obj = issue[fields[k].id]; 
	                	if(obj){
	                		var fisheyeTable = AJS.$('<table/>',{
	                			'class':'aui'
	            			});
	            			var commits = obj['list'];
	            			for(var l = 0; l < commits.length; l++){
	            				var commitTr = AJS.$('<tr/>');
	            				var commitObj = commits[l];
	            				
	        					commitTr.append(
	        						AJS.$('<td/>').append(
	        							commitObj.date
	        						).css({'font-size':'smaller','min-width':'100px'}),
	        						AJS.$('<td/>').append(
	        							AJS.$('<a/>', {
											'href':commitObj.link,
											'text':commitObj.message,
											'title':commitObj.id
										})
	        						).css({'font-size':'smaller','min-width':'150px'}),
	        						AJS.$('<td/>').append(
	        							commitObj.author
	        						).css({'font-size':'smaller','text-align':'right'})
	        					);
	        					fisheyeTable.append(commitTr);
	            			}
	                    	issueTD.append(fisheyeTable);
	                	}
	            	}else if(fields[k].id == 'last_comment'){
	                	var obj = issue[fields[k].id]; 
	                	if(obj && obj.body && obj.date && obj.author){
	                		var commentTable = AJS.$('<table/>',{
	                			'class':'aui'
	            			});
	        				commentTable.append(
	    						AJS.$('<tr/>').append(
		    						AJS.$('<td/>', {'colspan':'2'}).append(
		    							obj.body
		    						).css({'font-size':'smaller','min-width':'200px'})
	    						),
	    						AJS.$('<tr/>').append(
		    						AJS.$('<td/>').append(
		    							obj.date
		    						).css({'font-size':'smaller','min-width':'100px'}),
		    						AJS.$('<td/>').append(
		    							obj.author
		    						).css({'font-size':'smaller','min-width':'100px','text-align':'right'})
	    						)
	        				);
	                    	issueTD.append(commentTable);
	                	}
	            	}else{
	                	var obj = issue[fields[k].id]; 
	                	if(obj){
		                	if(obj.hasOwnProperty('list')){
		                		var list = obj.list;
		                		for(var l = 0; l < list.length; l++){
		                			this.parseData(list[l], issueTD, true);
			                		issueTD.append('<br/>');
		                		}
		                	}else{
	            				this.parseData(obj, issueTD, false);
		                	}
	                	}
	            	}
					issueRow.append(issueTD);
	            }
				table.append(issueRow);
				
				if(this.submodels){
					table.append(
						AJS.$('<tr/>').append(
							AJS.$('<td/>',{
								'colspan':fields.length
							}).css({
								'padding-left': '40px'
							}).append(
								AJS.$('<table/>',{
									'class':'aui',
									'id': tableId + issue['com.go2group.synapse.item.identificator']
								})
							)
						)
					);
					
					var tcSubtable = new SynapseRTTestPlansIssuePanel();
					tcSubtable.tableId = tableId + issue['com.go2group.synapse.item.identificator'];
					tcSubtable.issues = this.submodels[issue['com.go2group.synapse.item.identificator']].issues;
					tcSubtable.fields = this.submodels[issue['com.go2group.synapse.item.identificator']].fields;
					tcSubtable.stateColors = this.stateColors;
					tcSubtable.coloredRowsFieldId = this.coloredRowsFieldId;
					tcSubtable.customDesign = this.customDesign;
					tcSubtable.coloredRows = true;
					tcSubtable.statistics = false;
					tcSubtable.rebuild();
					
				}
	        }
	        
        }
        //paginator
        if (this.pages && parseInt(this.pages, 10) > 1){
        	console.log('building paginator: ' + this.pages);
        	this.pager = paginator(this.paginatorId, this.currentPage, this.pages, 5, function(panel){panel.changePage()}, null, this);          
        }else{
        	console.log('remove paginator: ' + this.pages);
        	AJS.$('#' + this.paginatorId).empty();
    	}
	}
	
	this.rebuildToolbar = function(){
		if(this.toolbarId){
			var toolbar = AJS.$('#' + this.toolbarId);
			toolbar.empty();
			if(this.filters){
				var filters = this.filters;
				for(var f=0; f<filters.length; f++){
					var filter = filters[f];
					var selectedFilters = this.selectedFilters;
					
					
if ((filter.name=="Assignee")&&(this.panelType=="test_plan4tps_issue_panel")){
	var selectAssignee = AJS.$('<form/>',{'style':'width:200px;float:left;'});
	var optList = AJS.$('<select/>',{'id':'el','style':'width:200px;'});
		
for(var j=0; j<filter.options.length; j++){
	var option = filter.options[j];
	var optionEl = AJS.$('<option/>',{
		'optionId':option.id,
	    'value':option.name,
		'text':option.name
	});
		optList.append(optionEl);
}

	selectAssignee.append(optList);
	optList.select2();
optList.change({
	filter:filter,
selectedFilters:selectedFilters,
optionId:option.id
},
function(e) {
	  if(e.data.optionId==-1){
			delete e.data.selectedFilters[e.data.filter.id];
		}else{
			e.data.selectedFilters[e.data.filter.id]=AJS.$(this).val();
		}
	  					
	  
});
	toolbar.append(selectAssignee);
	
}else{
					var filterButton = AJS.$('<button/>',{
						'class':'aui-button aui-button-subtle synapse-button-highlight aui-dropdown2-trigger',
						'aria-owns':this.toolbarId + filter.id,
						'aria-haspopup':'true',
						'text':filter.name
					});
					
					
					var optionsList = AJS.$('<ul/>', {'class':'aui-list-truncate synapse-issuepanel-dropdown-select'});
					
					for(var j=0; j<filter.options.length; j++){
						var option = filter.options[j];
						var optionEl = AJS.$('<a/>',{
							'href':'javascript:void(0);',
							'option_id':option.id,
							'text':option.name
						}).click(
							{
								button:filterButton,
								filter:filter,
								selectedFilters:selectedFilters,
								optionId:option.id
							},
							function(event){
								if(event.data.optionId==-1){
									event.data.button.text(event.data.filter.name);
									delete event.data.selectedFilters[event.data.filter.id];
								}else{
									event.data.button.text(AJS.$(this).text());
									event.data.selectedFilters[event.data.filter.id]=event.data.optionId;
								}
							}
						);
						optionsList.append(AJS.$('<li/>').append(optionEl));
					}
					
					
					var filterSelectDropDown = AJS.$('<div/>', {
						'class':'aui-dropdown2 aui-style-default',
						'id':this.toolbarId + filter.id,
						'style':'max-height:500px;'
					}).append(optionsList);
					
					toolbar.append(
						filterButton,
						filterSelectDropDown
					);
				}
				}
			}
			
			var queryButton = AJS.$('<button/>', {'class':'aui-button','text':'Query'}).click(
				{
					panel:this
				},
				function(event){
					event.data.panel.changePage(1);
				}
			).css({'margin-left':'10px'});
			
			var numberToLoadInput = AJS.$('<input/>', {
				'class':'synapse-issuepanel-number-to-load-input',
				'id':this.toolbarId + '-number-to-load-input'
			});
			if(this.numberToLoad)
				numberToLoadInput.val(this.numberToLoad);
	    	this.numberToLoadInput = numberToLoadInput;
			toolbar.append(
				AJS.$('<label/>', {
					'class':'synapse-issuepanel-number-to-load-label',
					'text':'Number Test Cases to load: ',
					'for':this.toolbarId + '-number-to-load-input'
				}),
				numberToLoadInput
			);
			console.log('append button');
			toolbar.append(queryButton);
		}
	}
	
	this.changePage = function(page){
		console.log('change page from ' + this.currentPage);
		if(page)
			this.currentPage=page;
		else
			this.currentPage = parseInt(AJS.$('#'+this.paginatorId).attr('currentpage'), 10);
		console.log('to ' + this.currentPage);
		this.startIndex = this.currentPage-1;
		this.reload();
	}
	
	this.parseData = function(obj, issueTD, label){
		if(obj && issueTD){
        	var text = null;
        	var link = null;
        	var img = null;
        	var tooltip = null;

        	
        	if(Object.prototype.toString.call(obj) == '[object String]')
        		text = obj;
        	if(obj.hasOwnProperty('text'))
        		text = obj.text;
        	if(obj.hasOwnProperty('link'))
        		link = obj.link;
        	if(obj.hasOwnProperty('tooltip'))
        		tooltip = obj.tooltip;
        	if(obj.hasOwnProperty('icon')){
        		img = AJS.$('<img/>',{
    				'border':'0',
    				'src':AJS.contextPath()+obj.icon,
    				'width':'16',
    				'height':'16',
    				'alt':'moveleft',
    				'title':'Move column left'
    			});
        		issueTD.append(img,"&nbsp;");
        	}
        	
        	if(link!=null)
        		issueTD.append(AJS.$('<a/>',{'href':AJS.contextPath()+link,'text':text,'title':tooltip}));
        	else if(label)
            	issueTD.append(AJS.$('<span/>',{'class':'aui-label'}).append(text));
        	else
            	issueTD.append(text);
    	}
	}
	
	this.sort = function(fieldHeader){
		var fieldId = fieldHeader.attr('fieldId');
		if(fieldId && fieldId.length){
			if(this.orderBy != fieldId){
				this.orderType = null;
			}
			this.orderBy = fieldId;
		}
		
		if(this.orderType == 'ASC')
			this.orderType = 'DESC';
		else if(this.orderType == 'DESC'){
			this.orderType = null;
			this.orderBy = null;
		}else
			this.orderType = 'ASC';
		console.log('order by ' + fieldId);
		this.changePage(1);
	}
	
	
	this.executeAction = function(actionId, data){
		if(actionId=='refresh'){
			this.reloadStats();
			this.reloadOperations();
			this.reload();
		}else{
			var data = 'issueKey='+this.issueKey
					+ '&panelType=' + this.panelType + '&action=execute'
					+ '&action=execute&execute=' + actionId + '&data=' + data;
	        console.log('loading tc panel: ' + data);
	        AJS.$.ajax({
	            url: AJS.contextPath() + '/plugins/servlet/customizableTestPlanPanelServlet',
	            async: false,
	            type: 'POST',
	            data: data,
	            panel: this,
	            success: function(result) {
	            	console.log('got result: ' + result);
	                var obj = JSON.parse(result);
	
	                if (obj.errors) {
	                    var tcErrorMsg = AJS.$('#tcErrorMsg')
	                    if(obj.errors.length > 0) {
	                        for(var i = 0; i < obj.errors.length; i++) {
	                            tcErrorMsg.append(AJS.$('<p/>').text(obj.errors[i]));
	                        }
	
	                        tcErrorMsg.show();
	                    } else {
	                        tcErrorMsg.hide();
	                    }
	                }
	                
	                if(obj.messages){
	                	this.panel.messages = obj.messages;
	                }else
	                	this.panel.messages = null;
	                
	            }
	        });
			//this.reloadStats();
			this.reloadOperations();
			this.reload();
        }
	}
	
}