SynapseRTPanel = function(tableId, paginatorId, errorDivId, panelType, contentType){
	this.tableId = tableId;
	this.paginatorId = paginatorId;
	this.startIndex = 0;
	this.panelType = panelType;
	this.contentType = contentType;
	this.pages;
	this.customDesign;
	this.currentPage = 1;
	this.issues;
	this.fields;
	this.pager;
	this.orderType;
	this.orderBy;
	this.stateColors;
	this.data = 'content=' + this.contentType + '&panelType=' + this.panelType;
	//Must be set to color rows according to state
	this.coloredRows = false;
	this.coloredRowsFieldId;
	
this.init = function(){
		//this.currentPage = 1;
		//this.startIndex = 0;
		
		}
	
	this.reload = function(data){
		
			
		if (data=='undefined'){
       data = this.data;
		}		
		data += '&startIndex=' + this.startIndex;
	
		if(this.orderType && this.orderBy)
				data += '&orderType=' + this.orderType + '&orderBy=' + this.orderBy;
	
		console.log('loading tc panel: ' + data);
        AJS.$.ajax({
            url: AJS.contextPath() + '/plugins/servlet/customizablePanelServlet',
            async: false,
            type: 'POST',
            data: data,
            panel: this,
            success: function(result) {
            	console.log('got result: ' + result);
                var obj = JSON.parse(result);

                if (obj.errors) {
                    var errorMsg = AJS.$('#' + errorDivId);
                    errorMsg.empty();
                    if(obj.errors.length > 0) {
                        for(var i = 0; i < obj.errors.length; i++) {
                            AJS.messages.error('#' + errorDivId, {
							   title:obj.errors[i]
							});
                        }
                        errorMsg.show();
                    }
                }

                if (obj.pages && parseInt(obj.pages, 10) > 0) {
                	this.panel.pages = obj.pages;
                }
									
                if(obj.issues) {
                	this.panel.issues = obj.issues;
                }
                					
                if(obj.fields) {
                	this.panel.fields = obj.fields;
                }
                
                if(obj.stateColors){
                	this.panel.stateColors = obj.stateColors;
                }
                
                if(obj.coloredRowsFieldId){
                	this.panel.coloredRowsFieldId = obj.coloredRowsFieldId;
                }
                
                if(obj.customDesign){
                	this.panel.customDesign = obj.customDesign;
                }
                
                this.panel.rebuild();
            }
        });
	}
	
	this.rebuild = function(){
		var tableId = this.tableId;
		console.log('rebuild panel ' + tableId);
		var table = AJS.$('#' + tableId);
		var issues = this.issues;
		var fields = this.fields;
		table.empty();
		//TODO headers should be provided by specific field of servlet's response;
		
		var headerRow = AJS.$('<tr/>');
        for (var j = 0; j < fields.length; j++) {
        	
             	var name="";
	        	if (fields[j].name=="Widget"){
	                	if(this.contentType=="bug"){name="Bug";}else if(this.contentType=="req"){name="Requirement";}
	                	else{name="Test Case";}
	        	}
	        	else if (fields[j].name=="Parent"){
	        		
	        		if(this.panelType=="requirement_issue_panel"){name="Parent Requirement"}
                	else if ((this.panelType=="test_case_issue_panel")
                	||(this.panelType=="test_plan4tcs_issue_panel_subtables")
                	||(this.panelType=="defect_coverage_issue_panel")
                	||(this.panelType=="test_plan4tps_issue_panel")
                	){name="Parent Test Case"}
                	else{name="Parent"}
        	}
	        	else{
        		name = fields[j].name;
        	}
	    
        	var fieldHead = AJS.$('<th/>',{'text':name});
        	
        	if(fields[j].id == this.orderBy){
        		if(this.orderType == 'ASC')
        			fieldHead.addClass('synapse-sort-asc');
        		else if(this.orderType == 'DESC')
        			fieldHead.addClass('synapse-sort-desc');
        	}
        	
        	if(fields[j].orderable == '1'){
        		fieldHead.attr('fieldId', fields[j].id);
        		fieldHead.css('cursor','pointer');
            	fieldHead.click(
					{panel:this},
					function(event){
						event.data.panel.sort(AJS.$(this));
					}
				);
			}
			headerRow.append(fieldHead);
        }
		table.append(headerRow);
		
		if(!issues || issues.length==0){
			var issueRow = AJS.$('<tr/>');
			var issueTD = AJS.$('<td/>', {
				'colspan':fields.length,
				'text':AJS.I18n.getText('com.go2group.synapse.panel.view.no.issues')
			}).css({'text-align': 'center'});
			issueRow.append(issueTD);
			table.append(issueRow);
		}else{
	        for (var j = 0; j < issues.length; j++) {
	        	var issue = issues[j];
	        	var issueRow = AJS.$('<tr/>');
	        	
	        	//Coloring issue row according to state
	        	if(this.coloredRows){

	        		if(this.coloredRows&&this.coloredRowsFieldId&&(issue[this.coloredRowsFieldId]!="")){
	        	        var colorRowsFieldObj = issue[this.coloredRowsFieldId];
	        	              
	        	        if (colorRowsFieldObj!=""){
	        	        	if(colorRowsFieldObj.hasOwnProperty('text')){
	        	            var colorRowsFieldVal = colorRowsFieldObj.text;
	        	              console.log('colorRowsFieldVal ' + colorRowsFieldVal);
	        	           issueRow.css({'background-color':this.stateColors[colorRowsFieldVal]});
	        	           }
	        	           }
	        	              
	        	          }
	        		       
	        	}
	        	
	            for (var k = 0; k < fields.length; k++) {
	            	console.log('parse field ' + fields[k].id);
	            	var issueTD = AJS.$('<td/>');
	            	if(fields[k].id == 'com.go2group.jira.plugin.synapse.widget'){
	                	var obj = issue[fields[k].id]; 
	                	if(obj){
	                		if(this.customDesign == "on"){
		                        var divWidgetTable = AJS.$('<div/>', {
		                            'class': 'synapse-tab-widget-table'
		                        });
	                        	                	
								console.log("--------"+obj.status);
								var divWrapper ="";
								if(obj.status=="Closed"){
									 divWrapper = AJS.$('<div/>', {
										'class': 'synapse-custom-issuepanel-issue-item-wrapper ' + getClassColorKey(obj.status)
									});
		        
								}else{
									 divWrapper = AJS.$('<div/>', {
										'class': 'synapse-custom-issuepanel-issue-item-wrapper ' + getClassColorKey(obj.state)
									});
		        
								}
								
								
								var divWidget = AJS.$('<div/>', {
									'class': 'synapse-custom-cf-issue-item-widget'
								}).css({
									'cursor': 'pointer'
								}).click(
									function(){
										window.open(AJS.contextPath() + '/browse/' + AJS.$(this).text(), '_blank');
									}
								).append(
									obj.key
								);
								
								
	                            divWidgetTable.append(
	                            	AJS.$('<div/>', {
	                                	'class': 'synapse-tab-widget-cell'
	                            	}).append(
	                            		divWrapper.append(
	                            			divWidget,
											AJS.$('<div/>', {
												'class': 'synapse-cf-issue-item-summary'
											}).append(
												AJS.$('<p/>').text(obj.summary)
											)
	                            		)
	                            	)
	                        	);
	                    		issueTD.append(divWidgetTable);
	                        }else{
		                        var divWidgetTable = AJS.$('<div/>', {
		                            'class': 'synapse-tab-widget-table'
		                        });
		                		var divWidgetKey = AJS.$('<div/>', {
		                           	'class': 'synapse-tab-widget-key',
		                            'click': function() {
		                                window.open(AJS.contextPath() + "/browse/" + AJS.$(this).text(), '_blank');
		                            }
		                        }).text(obj.key).css("background-color", obj.issuetypecolor);
		
		                        
		                        
var divWidgetInfo ="";
if(obj.status=="Closed"){
	 divWidgetInfo = AJS.$('<div/>', {
        'class': 'synapse-tab-widget-info ' + getClassColorKey(obj.status)
    }).text(obj.summary);
		}else{
	 divWidgetInfo = AJS.$('<div/>', {
        'class': 'synapse-tab-widget-info ' + getClassColorKey(obj.state)
    }).text(obj.summary);
		}



		                        divWidgetTable.append(
		                        	AJS.$('<div/>', {
		                            	'class': 'synapse-tab-widget-cell'
		                        	}).append(
		                        		AJS.$('<div/>', {
			                                'class': 'synapse-tab-widget',
			                                'title': obj.summary
			                            }).append(
			                            	divWidgetKey,
		                            		divWidgetInfo
		                        		)
		                        	)
		                    	);
		                    	issueTD.append(divWidgetTable);
		                	}
						}
					}else if(fields[k].id == 'com.go2group.jira.plugin.synapse.fisheye'){
						var obj = issue[fields[k].id]; 
						if(obj){
							var fisheyeTable = AJS.$('<table/>',{
								'class':'aui'
							});
							var commits = obj['list'];
							for(var l = 0; l < commits.length; l++){
								var commitTr = AJS.$('<tr/>');
								var commitObj = commits[l];
								
								commitTr.append(
									AJS.$('<td/>').append(
										commitObj.date
									).css({'font-size':'smaller','min-width':'100px'}),
									AJS.$('<td/>').append(
										AJS.$('<a/>', {
											'href':commitObj.link,
											'text':commitObj.message,
											'title':commitObj.id
										})
									).css({'font-size':'smaller','min-width':'150px'}),
									AJS.$('<td/>').append(
										commitObj.author
									).css({'font-size':'smaller','text-align':'right'})
								);
								fisheyeTable.append(commitTr);
							}
							issueTD.append(fisheyeTable);
						}
					}else if(fields[k].id == 'last_comment'){
						var obj = issue[fields[k].id]; 
						if(obj && obj.body && obj.date && obj.author){
							var commentTable = AJS.$('<table/>',{
								'class':'aui'
							});
							commentTable.append(
								AJS.$('<tr/>').append(
									AJS.$('<td/>', {'colspan':'2'}).append(
										obj.body
									).css({'font-size':'smaller','min-width':'200px'})
								),
								AJS.$('<tr/>').append(
									AJS.$('<td/>').append(
										obj.date
									).css({'font-size':'smaller','min-width':'100px'}),
									AJS.$('<td/>').append(
										obj.author
									).css({'font-size':'smaller','min-width':'100px','text-align':'right'})
								)
							);
							issueTD.append(commentTable);
						}
					}else{
						var obj = issue[fields[k].id]; 
						if(obj){
							if(obj.hasOwnProperty('list')){
								var list = obj.list;
								for(var l = 0; l < list.length; l++){
									this.parseData(list[l], issueTD, true);
									issueTD.append('<br/>');
								}
							}else{
								this.parseData(obj, issueTD, false);
								
							}
						}
					}
					issueRow.append(issueTD);
				}
				table.append(issueRow);
			}
        }
        
        //paginator
        if (this.pages && parseInt(this.pages, 10) > 0)
        	this.pager = paginator(this.paginatorId, this.currentPage, this.pages, 5, function(panel){panel.changePage()}, null, this);          
        
	}
	
	this.changePage = function(page){
		console.log('change page from ' + this.currentPage);
		if(page)
			this.currentPage=page;
		else
			this.currentPage = parseInt(AJS.$('#'+this.paginatorId).attr('currentpage'), 10);
		console.log('to ' + this.currentPage);
		this.startIndex = this.currentPage-1;
		this.reload(this.data);
	}
	
	this.parseData = function(obj, issueTD, label){
		if(obj && issueTD){
        	var text = null;
        	var link = null;
        	var img = null;
        	var tooltip = null;

        	
        	if(Object.prototype.toString.call(obj) == '[object String]')
        		text = obj;
        	if(obj.hasOwnProperty('text'))
        		text = obj.text;
        		
        	if(obj.hasOwnProperty('link'))
        		link = obj.link;
        	if(obj.hasOwnProperty('tooltip'))
        		tooltip = obj.tooltip;
        	if(obj.hasOwnProperty('icon')){
        		img = AJS.$('<img/>',{
    				'border':'0',
    				'src':AJS.contextPath()+obj.icon,
    				'width':'16',
    				'height':'16',
    				'alt':'moveleft',
    				'title':'Move column left'
    			});
        		issueTD.append(img,"&nbsp;");
        	}
        	
        	if(link!=null)
        		issueTD.append(AJS.$('<a/>',{'href':AJS.contextPath()+link,'text':text,'title':tooltip}));
        	else if(label)
            	issueTD.append(AJS.$('<span/>',{'class':'aui-label'}).append(text));
        	else
            	issueTD.append(text);
    	}
	}
	
	this.sort = function(fieldHeader){
		var fieldId = fieldHeader.attr('fieldId');
		if(fieldId && fieldId.length){
			if(this.orderBy != fieldId){
				this.orderType = null;
			}
			this.orderBy = fieldId;
		}
		
		if(this.orderType == 'ASC')
			this.orderType = 'DESC';
		else if(this.orderType == 'DESC'){
			this.orderType = null;
			this.orderBy = null;
		}else
			this.orderType = 'ASC';
		console.log('order by ' + fieldId);
		this.changePage(1);
		}
	
}
	


SynapseRTIssuePanel = function(panel, issueKey){
	
	SynapseRTPanel.call(this, panel);
	this.issueKey = issueKey;
	
	panel.data = panel.data + '&issueKey='+this.issueKey;
	panel.reload(panel.data);
}


SynapseRTProjectPanel = function(panel, projectKey, testSuite){

	if(testSuite instanceof Array) {

for (var i=0;i<testSuite.length;i++)
{ 
      this.testSuite = testSuite[i];
      SynapseRTPanel.call(this, panel);
  	this.projectKey = projectKey;

  	panel.data = panel.data + '&projectKey='+this.projectKey+'&testSuite='+this.testSuite;
      panel.reload(panel.data);
}
	
	} else {
		this.testSuite = testSuite;
		SynapseRTPanel.call(this, panel);
		this.projectKey = projectKey;

		panel.data = panel.data + '&projectKey='+this.projectKey+'&testSuite='+this.testSuite;
	    panel.reload(panel.data);
}
}
