function paginator(divId, currentPage, pages, pagesInRow, functionToCall, child, parameter) {
    AJS.$('#' + divId).html('');
    if(pages){
	    if (currentPage > pages)
	        currentPage = pages;
	    if (pagesInRow > pages)
	        pagesInRow = pages;
	
	    var currentPagePosition = currentPage % pagesInRow;
	    if (currentPagePosition == 0)
	        currentPagePosition = pagesInRow;
	
	    var minPage = currentPage - currentPagePosition + 1;
		if(minPage<1)
			minPage = 1;
	    var maxPage = minPage + pagesInRow - 1;
	
	    // styling
	    outOfRangeText = (child == 'child' ? 'synapse-pager-small-jump-to' : 'synapse-pager-jump-to');
	    pagerButton = (child == 'child' ? 'synapse-pager-small-button' : 'synapse-pager-button');
	    pagerButtonDisabled = (child == 'child' ? 'synapse-pager-small-button-disabled' : 'synapse-pager-button-disabled');
	    pagerButtonSelected = (child == 'child' ? 'synapse-pager-small-button-selected' : 'synapse-pager-button-selected');
	
	    //
	
	    var divElement = '';
	    if (currentPage > pagesInRow) {
	        // A<<
	        var lowestPageNumber = ((minPage - pagesInRow * pagesInRow) < 1) ? 1 : minPage - pagesInRow * pagesInRow;
	        
	        //'first page' button
	        if(lowestPageNumber>1){
		    	divElement = AJS.$('<div />', {
		            html: '...',
		            click: function() {
		                paginator(divId, 1, pages, pagesInRow, functionToCall, child, parameter);
		                functionToCall(parameter);
		            }
		        }).addClass(pagerButton);
		        AJS.$(divElement).appendTo('#' + divId);
	        }
	        
	        divElement = AJS.$('<div />', {
	            html:lowestPageNumber
	        }).addClass(outOfRangeText);
	        AJS.$(divElement).appendTo('#' + divId);
	
	        divElement = AJS.$('<div />', {
	            html: '&lt;&lt;',
	            click: function() {
	                paginator(divId, lowestPageNumber, pages, pagesInRow, functionToCall, child, parameter);
	                functionToCall(parameter);
	            }
	        }).addClass(pagerButton);
	        AJS.$(divElement).appendTo('#' + divId);
	
	        // B<
	        divElement = AJS.$('<div />', {
	            html: minPage - 1
	        }).addClass(outOfRangeText);
	        AJS.$(divElement).appendTo('#' + divId);
	
	        divElement = AJS.$('<div />', {
	            html: '&lt;',
	            click: function() {
	                paginator(divId, minPage - 1, pages, pagesInRow, functionToCall, child, parameter);
	                functionToCall(parameter);
	            }
	        }).addClass(pagerButton);
	        AJS.$(divElement).appendTo('#' + divId);
	    } else {
	        divElement = AJS.$('<div />', {
	            html: '&lt;&lt;'
	        }).addClass(pagerButtonDisabled);
	        AJS.$(divElement).appendTo('#' + divId);
	        divElement = AJS.$('<div />', {
	            html: '&lt;'
	        }).addClass(pagerButtonDisabled);
	        AJS.$(divElement).appendTo('#' + divId);
	    }
	
	    if(maxPage + 1 <= pages) {
	        var numberArray = [];
	        for(var k = 0; k < pagesInRow; k++) {
	            numberArray[k] = k + 1;
	        }
	
	        AJS.$(numberArray).each(function(index, value) {
	            divElement = '';
	            // pages
	            if(value == currentPagePosition) {
	                divElement = AJS.$('<div />', {
	                    html: currentPage
	                }).addClass(pagerButtonSelected);
	                AJS.$(divElement).appendTo('#' + divId);
	                AJS.$('div#' + divId).attr('currentpage', currentPage);
	            } else {
	                var printPage = minPage + value - 1;
	                divElement = AJS.$('<div />', {
	                    html: printPage,
	                    click: function() {
	                        paginator(divId, printPage, pages, pagesInRow, functionToCall, child, parameter);
	                        functionToCall(parameter);
	                    }
	                }).addClass(pagerButton);
	                AJS.$(divElement).appendTo('#' + divId);
	            }
	        });
	    } else {
	        var numberArray = [];
	        var pagesInRowNotFull = pages - minPage + 1;
	        for(var k = 0; k < pagesInRowNotFull; k++) {
	            numberArray[k] = k + 1;
	        }
	
	        AJS.$(numberArray).each(function(index, value) {
	            divElement = '';
	            // pages
	            if(value == currentPagePosition) {
	                divElement = AJS.$('<div />', {
	                    html:currentPage
	                }).addClass(pagerButtonSelected);
	                AJS.$(divElement).appendTo('#' + divId);
	                AJS.$('div#' + divId).attr('currentpage', currentPage);
	            } else {
	                var printPage = minPage + value - 1;
	                divElement = AJS.$('<div />', {
	                    html: printPage,
	                    click: function() {
	                        paginator(divId, printPage, pages, pagesInRow, functionToCall, child, parameter);
	                        functionToCall(parameter);
	                    }
	                }).addClass(pagerButton);
	                AJS.$(divElement).appendTo('#' + divId);
	            }
	        });
	    }
	
	    if (maxPage + 1 < pages) {
	        // >C
	        divElement = AJS.$('<div />', {
	            html:'&gt;',
	            click: function() {
	                paginator(divId, maxPage + 1, pages, pagesInRow, functionToCall, child, parameter);
	                functionToCall(parameter);
	            }
	        }).addClass(pagerButton);
	        AJS.$(divElement).appendTo('#' + divId);
	
	        divElement = AJS.$('<div />', {
	            html: maxPage + 1
	        }).addClass(outOfRangeText);
	        AJS.$(divElement).appendTo('#' + divId);
	        // >>D
	        var biggestPageNumber = ((maxPage + pagesInRow * pagesInRow) > pages) ? pages : maxPage + pagesInRow * pagesInRow;
	        divElement = AJS.$('<div />', {
	            html: '&gt;&gt;',
	            click: function() {
	                paginator(divId, biggestPageNumber, pages, pagesInRow, functionToCall, child, parameter);
	                functionToCall(parameter);
	            }
	        }).addClass(pagerButton);
	        AJS.$(divElement).appendTo('#' + divId);
	
	        divElement = AJS.$('<div />', {
	            html: biggestPageNumber
	        }).addClass(outOfRangeText);
	        AJS.$(divElement).appendTo('#' + divId);
	        
	        
	        //'last page' button
	        if(biggestPageNumber<pages){
		    	divElement = AJS.$('<div />', {
		            html: '...',
		            click: function() {
		                paginator(divId, pages, pages, pagesInRow, functionToCall, child, parameter);
		                functionToCall(parameter);
		            }
		        }).addClass(pagerButton);
		        AJS.$(divElement).appendTo('#' + divId);
	        }
	    } else if (maxPage + 1 == pages) {
	        // >C
	        divElement = AJS.$('<div />', {
	            html: '&gt;',
	            click: function() {
	                paginator(divId, maxPage + 1, pages, pagesInRow, functionToCall, child, parameter);
	                functionToCall(parameter);
	            }
	        }).addClass(pagerButton);
	        AJS.$(divElement).appendTo('#' + divId);
	
	        divElement = AJS.$('<div />', {
	            html: maxPage + 1
	        }).addClass(outOfRangeText);
	        AJS.$(divElement).appendTo('#' + divId);
	        // >>
	        divElement = AJS.$('<div />', {
	            html: '&gt;&gt;'
	        }).addClass(pagerButtonDisabled);
	        AJS.$(divElement).appendTo('#' + divId);
	    } else {
	        // >
	        divElement = AJS.$('<div />', {
	            html: '&gt;'
	        }).addClass(pagerButtonDisabled);
	        AJS.$(divElement).appendTo('#' + divId);
	
	        // >>
	        divElement = AJS.$('<div />', {
	            html: '&gt;&gt;'
	        }).addClass(pagerButtonDisabled);
	        AJS.$(divElement).appendTo('#' + divId);
	    }
	    if (typeof window['bindStatisticsPopupForPaginator'] == 'function') {
	        bindStatisticsPopupForPaginator();
	    }
    }
}