SynapseRTPanelConfigurationAdmin = function(fieldsSelect,configTable,addButton,panelType){
	this.fieldsSelect = fieldsSelect;//'synapse-configure-columns-dialog-available-fields';
	this.configTable = configTable;//'synapse-configure-columns-dialog-table';
	this.addButton = addButton;//'synapse-configure-columns-dialog-add-button';
	this.panelType = panelType;//'test.case.coverage.issue.panel';
	this.synapseConfigureColumnsDialog;
	this.synapseFields;
	this.baseFields;
	this.customFields;
	this.configuration;
	
	this.init = function(){
		
		AJS.$('#' + this.addButton).click(
			{dialog:this},
			function(event){
				event.data.dialog.addField();
			}
		);
	    this.reload();
	}
	
	this.reload = function(){
		var data = "type=" + this.panelType + "&action=admininit";
		console.log('load configuration: ' + data);
		AJS.$.ajax({
            url: AJS.contextPath() + '/plugins/servlet/panelConfigurationServlet',
            async: false,
            type: 'POST',
            data: data,
            dialog: this,
            success: function(result) {
            	console.log('got result: ' + result);
            	var obj = JSON.parse(result);
            	
            	if(obj.synapseFields){
            		this.dialog.synapseFields = obj.synapseFields;
            	}
            	
            	if(obj.baseFields){
            		this.dialog.baseFields = obj.baseFields;
            	}
            	
            	if(obj.customFields){
            		this.dialog.customFields = obj.customFields;
            	}
            	
            	if(obj.configuration){
            		this.dialog.configuration = obj.configuration;
        		}
        		
        		this.dialog.rebuild();
        	}
    	});
	}
	
	this.rebuild = function(){
		console.log('rebuild configuration dialog');
		AJS.$('#' + this.fieldsSelect).empty();
		AJS.$('#' + this.configTable).empty();
		
		if(this.synapseFields){
    		var synapseFields = this.synapseFields;
    		var optGroup = AJS.$('<optgroup/>', {'id':'synapse-synapsefields-optgroup','label':'SynapseRT fields'});
    		for(var j=0; j<synapseFields.length; j++){
    			var field = synapseFields[j];
    			console.log('add option ' + field.id + ' : '+ field.name);
    			 if (field.name=="Parent"){
                  	if(this.panelType=="requirement_issue_panel"){name="Parent Requirement"}
                  	else if ((this.panelType=="test_case_issue_panel")
                  	||(this.panelType=="test_plan4tcs_issue_panel_subtables")
                  	||(this.panelType=="defect_coverage_issue_panel")
                  	||(this.panelType=="test_plan4tps_issue_panel")){name="Parent Test Case"}
                  	else{name="Parent"}
          	}else{
          		name=field.name;
          	}    	
     			var option = AJS.$('<option/>', {'value':field.id, 'text':name});    			optGroup.append(option);
    		}
    		console.log('add optgroup ' + optGroup.html() + ' to ' + this.fieldsSelect);
    		AJS.$('#' + this.fieldsSelect).append(optGroup);
    		

    		}
    		
    		
   if(this.baseFields){
    		var baseFields = this.baseFields;
    		var optGroup = AJS.$('<optgroup/>', {'id':'synapse-basefields-optgroup','label':'Jira Base fields'});
    		for(var j=0; j<baseFields.length; j++){
    			var field = baseFields[j];
    			
    			console.log('add option ' + field.id + ' : '+ field.name);
				
var name="";
if (field.name=="Widget"){
	if(this.panelType=="defect_coverage_issue_panel"){name="Defect";}
	else if(this.panelType=="requirement_issue_panel"){name="Requirement";}
    else if((this.panelType=="test_plan4tcs_issue_panel")||(this.panelType=="test_plan_issue_panel")){name="Test Plans";}
	else if(this.panelType=="test_suite_issue_panel"){ name = "Test Suite";}
	                	else{name="TestCase(SubTest)";}
}


	        	else{
	        		name = field.name;
	        	}

    			var option = AJS.$('<option/>', {'value':field.id, 'text':name});
    			optGroup.append(option);
    		}
    		console.log('add optgroup ' + optGroup.html());
    		AJS.$('#' + this.fieldsSelect).append(optGroup);
    	}
    
    	
    	if(this.customFields){
    		var customFields = this.customFields;
    		var optGroup = AJS.$('<optgroup/>', {'id':'synapse-customfields-optgroup','label':'Jira Custom fields'});
    		for(var j=0; j<customFields.length; j++){
    			var field = customFields[j];
    			console.log('add option ' + field.id + ' : '+ field.name);
    			var option = AJS.$('<option/>', {'value':field.id, 'text':field.name});
    			optGroup.append(option);
    		}
    		console.log('add optgroup ' + optGroup.html() + ' to ' + this.fieldsSelect);
    		AJS.$('#' + this.fieldsSelect).append(optGroup);
    	}
    	
    	if(this.configuration){
    		var configuration = this.configuration;
    		var fields = configuration.fields;
			var trHeaders = AJS.$('<tr/>');
			var trControls = AJS.$('<tr/>');
    		for(var j=0; j<fields.length; j++){
    			var field = fields[j];
    			var option = AJS.$('#' + this.fieldsSelect).find('option[value="' + field.id + '"]');
    			var fieldDisplayName = option.text();
    			if(fieldDisplayName.length){
    				option.remove();
    				
var name="";
if (fieldDisplayName=="Widget"){
	if(this.panelType=="defect_coverage_issue_panel"){name="Defect";}
	 else if(this.panelType=="requirement_issue_panel"){name="Requirement";}
     else if((this.panelType=="test_plan4tcs_issue_panel")||(this.panelType=="test_plan_issue_panel")){name="Test Plans";}
	 else if((this.panelType=="test_suite_issue_panel")){ name = "Test Suite";}
	                	else{name="TestCase(SubTest)";}
}else if (fieldDisplayName=="Parent"){
if(this.panelType=="requirement_issue_panel"){name="Parent Requirement";}
else if ((this.panelType=="test_case_issue_panel")
||(this.panelType=="test_plan4tcs_issue_panel_subtables")
||(this.panelType=="defect_coverage_issue_panel")
||(this.panelType=="test_plan4tps_issue_panel")){name="Parent Test Case";}
else{name="Parent";}
} 
        	else{
        		name = fieldDisplayName;
        	}
 			trHeaders.append(AJS.$('<th/>').append(name));
        			
        			var tdEl = AJS.$('<td/>');
        			if(j!=0){
            			var prev = AJS.$('<a/>',{
            						'href':'javascript:void(0);',
	                				'fieldid':field.id
            				}).append(
	                			AJS.$('<img/>',{
	                				'border':'0',
	                				'src':AJS.contextPath()+'/download/resources/com.go2group.jira.plugin.synapse/includes/img/aui/prev.gif',
	                				'width':'16',
	                				'height':'16',
	                				'alt':'moveleft',
	                				'title':'Move column left'
	                			})
            			).click(
            				{dialog:this},
            				function(event){
            					event.data.dialog.moveLeft(AJS.$(this).attr('fieldid'));
            				}
            			);
            			tdEl.append(prev);
        			}
            			
        			var trash = AJS.$('<a/>',{
        						'href':'javascript:void(0);',
                				'fieldid':field.id
        				}).append(
                			AJS.$('<img/>',{
                				'border':'0',
                				'src':AJS.contextPath()+'/download/resources/com.go2group.jira.plugin.synapse/includes/img/aui/trash_16.gif',
                				'width':'16',
                				'height':'16',
                				'alt':'totrash',
                				'title':'Hide column'
                			})
        			).click(
        				{dialog:this},
        				function(event){
        					event.data.dialog.toTrash(AJS.$(this).attr('fieldid'));
        				}
        			);
        			tdEl.append(trash);
        			
        			if(j!=fields.length-1){
            			var next = AJS.$('<a/>',{
            						'href':'javascript:void(0);',
	                				'fieldid':field.id
            				}).append(
	                			AJS.$('<img/>',{
	                				'border':'0',
	                				'src':AJS.contextPath()+'/download/resources/com.go2group.jira.plugin.synapse/includes/img/aui/next.gif',
	                				'width':'16',
	                				'height':'16',
	                				'alt':'moveright',
	                				'title':'Move column right'
	                			})
            			).click(
            				{dialog:this},
            				function(event){
            					event.data.dialog.moveRight(AJS.$(this).attr('fieldid'));
            				}
            			);
            			tdEl.append(next);
        			}
        			trControls.append(tdEl);
    			}
    		}
    		AJS.$('#' + this.configTable).append(trHeaders, trControls);
    	}
	}
	
	this.moveLeft = function(fieldId){
		console.log('move left, field id: ' + fieldId);
		if(this.configuration){
    		var fields = this.configuration.fields;
			var targetIndex = 0;
			var targetField = null;
    		for(var j=0; j<fields.length; j++){
    			var field = fields[j];
    			if(field.id == fieldId){
    				targetIndex = j;
    				targetField = field;
    				break;	
				}
			}
			if(targetIndex>0 && targetIndex<this.configuration.fields.length){
				console.log('target index ' + targetIndex + '; id '+targetField.id)
				this.configuration.fields[targetIndex] = this.configuration.fields[targetIndex-1];
				this.configuration.fields[targetIndex-1] = targetField;
			}
			this.rebuild();
		}
	}
	
	this.toTrash = function(fieldId){
		console.log('move to trash, field id: ' + fieldId);
		if(this.configuration){
    		var fields = this.configuration.fields;
			var newFields = [];
    		for(var j=0; j<fields.length; j++){
    			var field = fields[j];
    			if(field.id != fieldId){
    				newFields.push(field);
				}
			}
			this.configuration.fields = newFields;
			this.rebuild();
		}
	}
	
	this.moveRight = function(fieldId){
		console.log('move right, field id: ' + fieldId);
		if(this.configuration){
    		var fields = this.configuration.fields;
			var targetIndex = 0;
			var targetField = null;
    		for(var j=0; j<fields.length; j++){
    			var field = fields[j];
    			if(field.id == fieldId){
    				targetIndex = j;
    				targetField = field;
    				break;	
				}
			}
			if(targetIndex>=0 && targetIndex<this.configuration.fields.length-1){
				console.log('target index ' + targetIndex + '; id '+targetField.id)
				this.configuration.fields[targetIndex] = this.configuration.fields[targetIndex+1];
				this.configuration.fields[targetIndex+1] = targetField;
			}
			this.rebuild();
		}
	}
	
	this.addField = function(){
		var fieldId = AJS.$('#' + this.fieldsSelect).val();
		console.log('add field: ' + fieldId);
		var complete = false;
		
		if(this.synapseFields){
    		var synapseFields = this.synapseFields;
    		for(var j=0; j<synapseFields.length; j++){
    			var field = synapseFields[j];
    			if(field.id == fieldId){
    				console.log('field found');
        			this.configuration.fields.push({'id':field.id});
        			complete = true;
        			break;
    			}
    		}
    	}
    	
		if(this.baseFields){
    		var baseFields = this.baseFields;
    		for(var j=0; j<baseFields.length; j++){
    			var field = baseFields[j];
    			if(field.id == fieldId){
    				console.log('field found');
        			this.configuration.fields.push({'id':field.id});
        			complete = true;
        			break;
    			}
    		}
    	}
    	
    	if(this.customFields && !complete){
    		var customFields = this.customFields;
    		for(var j=0; j<customFields.length; j++){
    			var field = customFields[j];
    			if(field.id == fieldId){
    				console.log('field found');
        			this.configuration.fields.push({'id':field.id});
        			complete = true;
        			break;
    			}
    		}
    	}
    	
		this.rebuild();
	}
	
	this.save = function(){
		var confString = JSON.stringify(this.configuration);
		
		console.log('save configuration: ' + confString);
		
		return confString;
	}
	
}