if(!String.prototype.startsWith) {
    String.prototype.startsWith = function (str) {
        return !this.indexOf(str);
    }
}

if(!String.prototype.endsWith) {
    String.prototype.endsWith = function(str) {
        return this.indexOf(str, this.length - str.length) !== -1;
    }
}

function truncateText(div) {
    var p = div.children('p:only-child');
    p.css('margin', '0px;');
    var cont = true;
    
    if(p.outerHeight() <= div.height() && p.outerWidth() <= div.width()){
    	cont = false;
	}
    if(AJS.$(div).css('width')>0 && p.outerWidth() > AJS.$(div).css('width')){
    	cont = true;
	}
	if(p.html() && p.html().length>40){
    	cont = true;
	}
		
    while (cont) {
    	cont = false;
        var foo = [];
        if(p.html())
        	foo = p.html().split(/[\s]+/g);
        if(foo.length > 1){
            foo.pop();
            foo = foo.join(' ');
            foo = foo.substring(0, foo.length - 1);
        }else{
            foo = foo.join(' ');
            foo = foo.substring(0, 40);
      		p.html(foo + '...');
      		break;
        }
        p.html(foo + '...');
	    if(p.outerHeight() <= div.height() && p.outerWidth() <= div.width()){
	    	cont = false;
    	}
	    if(AJS.$(div).css('width')>0 && p.outerWidth() > AJS.$(div).css('width')){
	    	cont = true;
    	}
    }
}

function getClassColorInfo(state) {
    var classColor;
    if(state == 'Failed') {
        classColor = 'synapse-light-red';
    } else if(state == 'Can\'t Test') {
        classColor = 'synapse-light-yellow';
    } else if(state == 'Can&#39;t Test') {
        classColor = 'synapse-light-yellow';
    } else if(state == "Can't Test") {
        classColor = 'synapse-light-yellow';
    } else if(state == 'Cant Test') {
        classColor = 'synapse-light-yellow';
    } else if(state == 'In Progress') {
        classColor = 'synapse-light-sky';
    } else if(state == 'Passed') {
        classColor = 'synapse-light-green';
    }else if (state == 'Closed'){
    	classColor = 'synapse-deep-purple';
    }

    return classColor;
}

function getClassColorKey(state) {
    var classColor;
    if(state == 'Failed') {
        classColor = 'synapse-dark-red';
    } else if(state == 'Can\'t Test') {
        classColor = 'synapse-dark-yellow';
    } else if(state == 'Can&#39;t Test') {
        classColor = 'synapse-dark-yellow';
    } else if(state == "Can't Test") {
        classColor = 'synapse-dark-yellow';
    } else if(state == 'Cant Test') {
        classColor = 'synapse-dark-yellow';
    } else if(state == 'In Progress') {
        classColor = 'synapse-dark-sky';
    } else if(state == 'Passed') {
        classColor = 'synapse-dark-green';
    } else if (state == 'Closed'){
    	classColor = 'synapse-deep-purple';
    }

    return classColor;
}

JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function (e, context, reason) {
    if(AJS.$('#CfParent').length) {
        load_CfParent();
    }
    if(AJS.$('#CfReq').length) {
        load_CfReq();
    }
    if(AJS.$('#CfTc').length) {
        load_CfTc();
    }

    if(AJS.$('#test-steps-edit-table').length && AJS.$('#test-steps-edit-table').length>0) {
    	AJS.log('call steps function ' + AJS.$('#test-steps-edit-table').children().length+"======"+ AJS.$('#test-steps-edit-table').children().html());
    	  setTimeout(function(){   restartTCStepsEdit();
}, 1000); 

    }
     if(AJS.$('#test-steps-view-table').length && AJS.$('#test-steps-view-table').length>0) {
    	AJS.log('call steps function ' + AJS.$('#test-steps-view-table').children().length+"======"+ AJS.$('#test-steps-view-table').children().html());
    	  setTimeout(function(){   restartTCStepsView();
}, 1000); 

    }
	if(JIRA.Issues){
    	if(JIRA.Issues.InlineEdit){
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["testCase_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["req_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["parentrequirement_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["testcasesteps_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
        }else
        	console.log("No Inline Edit...");
    }else{
    	//console.log("No JIRA.Issues");
    }
    patchEditableSynapseFields();
    
    //TC CF
    console.log("custom JIRA event fired");
    console.log("reason: " + reason);
    if((reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed && AJS.$(context).find('#synapse-tc-cf').length>0) || 
    		reason == JIRA.CONTENT_ADDED_REASON.pageLoad){
    	console.log('reload synapseRT cf');
    	if(typeof(refreshCfTcView) != "undefined")
			refreshCfTcView();
		else
			console.log('no refreshCfTcView');
	}
	
	//console.log('CONTEXT: ' + AJS.$(context).html());
	//TP panel for Test plans
	if((reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed && AJS.$(context).find('#numberTcToLoadTpTab').length>0) || 
    		reason == JIRA.CONTENT_ADDED_REASON.pageLoad){
    	console.log('reload synapseRT tp tab of tps');
    	if(typeof(refreshPanelTPView) != "undefined")
			refreshPanelTPView('1');
		else
			console.log('no refreshPanelTPView');
	}
	
	
	//TC panel
	if((reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed && AJS.$(context).find('#tcDropSelect').length>0) || 
    		reason == JIRA.CONTENT_ADDED_REASON.pageLoad){
    	console.log('reload synapseRT tc panel at general');
    	if(typeof(restartTcPanel) != "undefined")
	    	restartTcPanel();
		else
			console.log('no restartTcPanel');
	}
	
	//REQ panel
	if((reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed && AJS.$(context).find('#reqDropSelect').length>0) || 
    		reason == JIRA.CONTENT_ADDED_REASON.pageLoad){
    	console.log('reload synapseRT req panel at general');
    	if(typeof(restartReqPanel) != "undefined")
			restartReqPanel();
		else
			console.log('no restartReqPanel');
	}
	
	//DEFECT panel
	if((reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed && AJS.$(context).find('#bugDropSelect').length>0) || 
    		reason == JIRA.CONTENT_ADDED_REASON.pageLoad){
    	console.log('reload synapseRT defect panel at general');
    	if(typeof(restartDefectCoveragePanel) != "undefined")
			restartDefectCoveragePanel();
		else
			console.log('no restartDefectCoveragePanel');
	}
	
});


JIRA.bind(JIRA.Events.INLINE_EDIT_BLURRED, function (e, context, reason) {
    silentPatchEditableSynapseFields();
});
JIRA.bind(JIRA.Events.INLINE_EDIT_FOCUSED, function (e, context, reason) {
    silentPatchEditableSynapseFields();
});
JIRA.bind(JIRA.Events.INLINE_EDIT_SAVE_COMPLETE, function (e, context, reason) {
    silentPatchEditableSynapseFields();
});

function evaluateSynapse(evalString)
{
    return document.evaluate(evalString, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
}

function patchEditableSynapseFields(){
	//console.log("disable editable fields");
	var patchSynapseFields = setInterval(function() {
		console.log("patch editable fields");
		var targetClasses = ['type-req_field', 'type-testCase_field', 'type-parentrequirement_field', 'type-testcasesteps_field'];
		for(var i=0; i < targetClasses.length; i++){
			var element = AJS.$('.' + targetClasses[i]);
			if(element.length && element.attr('class').length){
				console.log("got element with classname " + element.attr('class'));
				if(!AJS.$(element).hasClass("active")){
					var newClassName = element.attr('class').replace("editable-field","");
					element.attr('class', newClassName);
					if(AJS.$(element).attr("patched_field") != 1){
						if(AJS.$(element).find(".overlay-icon").length){
							AJS.$(element).find("[synapse_inline_edit]").attr("synapse_inline_edit", "1");
							AJS.$(element).attr("patched_field",1);
							AJS.$(element).click(
								{element:element},
								function(event) {
									//console.log("clicked on " + AJS.$(event.target).attr("class") + "|" + AJS.$(event.target).html());
									if(AJS.$(event.target).attr("synapse_inline_edit")=="1" || AJS.$(event.data.element).hasClass("active")){
										//console.log('patching class ' + AJS.$(element).attr('class'));
										AJS.$(element).attr('class', AJS.$(element).attr('class') + " editable-field");
										//console.log('patched class ' + AJS.$(element).attr('class'));
										//console.log("synapse inline edit button clicked or inline editing");
										//if cancel editing
										if(AJS.$(event.target).hasClass('icon-cancel')){
											silentPatchEditableSynapseFields();
										}
									}else{
										//console.log("stop propagation of click event from synapse field");
										event.stopPropagation();
										event.preventDefault();
										event.stopImmediatePropagation();
										//if cancel editing
										if(AJS.$(event.target).hasClass('icon-cancel')){
											silentPatchEditableSynapseFields();
										}
									}
								}
							);
						}
					}					
				}
				
				element.find('.overlay-icon').remove();
				element.css({'padding':'2px','cursor': 'initial'});
				AJS.$(element).attr("title","");
				
			}
		}
		
		console.log("fields patched");
		clearInterval(patchSynapseFields);
	},1000);
}

function silentPatchEditableSynapseFields(){
	var counter_index = 0;
	var patchSynapseFields = setInterval(function() {
		//console.log("silent patch editable field");
		var targetClasses = ['type-req_field', 'type-testCase_field', 'type-parentrequirement_field', 'type-testcasesteps_field'];
		for(var i=0; i < targetClasses.length; i++){
			var element = AJS.$('.' + targetClasses[i]);
			if(element.length && element.attr('class').length){
				//console.log("got element with classname " + element.attr('class'));
				AJS.$(element).attr("title","");
				if(!AJS.$(element).hasClass("active") && AJS.$(element).hasClass("editable-field")){
					var newClassName = element.attr('class').replace("editable-field","");
					element.attr('class', newClassName);
					//console.log("field patched - remove editable-field class");
				}
				
				if(AJS.$(element).hasClass("active") && !AJS.$(element).hasClass("editable-field")){
					//console.log('patching class ' + AJS.$(element).attr('class'));
					AJS.$(element).attr('class', AJS.$(element).attr('class') + " editable-field");
					//console.log('patched class ' + AJS.$(element).attr('class'));
				}
			}
		}
    	
		if(counter_index++ > 5)
			clearInterval(patchSynapseFields);
		
	},1000);
}


var addCustomBlurTriggers = setInterval(function() {
	//console.log("disable editable fields");
	if(JIRA.Issues){
    	if(JIRA.Issues.InlineEdit){
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["testCase_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["req_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["parentrequirement_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
	        JIRA.Issues.InlineEdit.BlurTriggerMapping.custom["testcasesteps_field"] = JIRA.Issues.InlineEdit.BlurTriggers.Default;
	        console.log("Blur triggers added, clear interval...");
	        clearInterval(addCustomBlurTriggers);
        }else
        	console.log("No Inline Edit");
    }else{
    	console.log("No JIRA.Issues");
    }
},1000);