SynapseRTTestSteps = function(tableId, fieldId, sgstnFieldId, msgDivId){
	this.srcFieldId = fieldId;
	this.suggestionFieldId = sgstnFieldId;
	this.tableId = tableId;
	this.field = {'steps':[]};
	this.suggestedMode = false;
	this.messageDivId = msgDivId;
	this.suggestedModeMsg;
	
	this.addStep = function(name, desc, expect){
		var newStep = {
			'name':name,
			'description':desc,
			'expected':expect
		};
		this.field.steps.splice(0,0,newStep);
		console.log(JSON.stringify(this.field.steps));
		this.rebuild();
		if(this.suggestedModeMsg)
			this.saveSuggested();
		AJS.$('#'+this.srcFieldId).val(JSON.stringify(this.field));
	}
	
	this.saveStep = function(step, name, desc, expect){
		var pos = this.field.steps.indexOf(step);
		if(pos!=-1){
			if(name)
    			step.name = name;
			if(desc)
    			step.description = desc;
			if(expect)
    			step.expected = expect;
    		
    		this.field.steps[pos] = step;
		}
		if(this.suggestedModeMsg)
			this.saveSuggested();
		AJS.$('#'+this.srcFieldId).val(JSON.stringify(this.field));
		return step;
	}
	
	this.move = function(from, to){
		this.field.steps.reverse();
		var step = this.field.steps[from];


		this.field.steps.splice(from,1);
		this.field.steps.splice(to,0,step);
		this.field.steps.reverse();

		if(this.suggestedModeMsg)
			this.saveSuggested();

			AJS.$('#'+this.srcFieldId).val(JSON.stringify(this.field));
	}
	
	this.removeStep = function(step){
		var pos = this.field.steps.indexOf(step);
		if(pos!=-1){
			this.field.steps.splice(pos,1);
		}
		if(this.suggestedModeMsg)
			this.saveSuggested();
		AJS.$('#'+this.srcFieldId).val(JSON.stringify(this.field));
	}
	
	this.init = function(){
		try{
			this.field = JSON.parse(AJS.$('#' + this.srcFieldId).val());
		}catch(ex){
			console.log(ex);
		}
		
		if(!this.field ||  !this.field.steps || !this.field.steps.length){
			try{
				console.log('Parse suggestion steps');
				console.log('e suggestion steps:-', this.suggestionFieldId);
				if(this.suggestionFieldId!=""){
				this.field = JSON.parse(AJS.$('#' + this.suggestionFieldId).val());
				}
				this.suggestedMode = true;
			}catch(ex){
				console.log('error parse suggestion steps:', ex);
			}
		}
		
		AJS.$('#'+this.messageDivId).empty();
		
		this.rebuild();
	}
	
	this.saveSuggested = function(){
		AJS.$('#'+this.srcFieldId).val(JSON.stringify(this.field));
		this.suggestedMode = false;
		this.suggestedModeMsg.remove();
	}
	
	this.rebuild = function(){
		var table = AJS.$('#' + this.tableId);
		if(table && table.length){
			table.empty();
			var thead = AJS.$('<thead/>');
			var tbody = AJS.$('<tbody/>');
			var headerTR = AJS.$('<tr/>');
			headerTR.append(AJS.$('<th/>',{'text':'#'}));
			headerTR.append(AJS.$('<th/>',{'text':'Name'}).css({'min-width':'100px'}));
			headerTR.append(AJS.$('<th/>',{'text':'Description'}).css({'min-width':'150px'}));
			headerTR.append(AJS.$('<th/>',{'text':'Expected results'}).css({'min-width':'150px'}));
			headerTR.append(AJS.$('<th/>'));
			table.append(thead.append(headerTR));
			
			if(this.suggestedMode){
				this.suggestedModeMsg = AJS.messages.warning('#'+this.messageDivId, {
				    title: 'Unsaved changes!',
				    body: 'This field is <strong>displaying</strong> steps created automatically from issue description. To apply current field value to the issue, close this message or change the field value.'
				});
				AJS.$(document).on('messageClose',{field: this, msg: this.suggestedModeMsg}, function (event,messageObj) {
					if(messageObj.attr('id')==event.data.msg.attr('id')){
						event.data.field.saveSuggested();
					}
				});
				this.suggestedMode = false;
			}
			
			var inputStepTR = AJS.$('<tr/>');
			inputStepTR.append(AJS.$('<td/>'));
			
			var newStepNameInput = AJS.$('<input/>', {
				'class':'text',
				'id':'newstep_name'
			});
			
			var newStepDescArea = AJS.$('<textarea/>', {
				'class':'textarea',
				'id':'newstep_desc',
				'rows':'3'
			});
			
			var newStepExpectArea = AJS.$('<textarea/>', {
				'class':'textarea',
				'id':'newstep_expected',
				'rows':'3'
			});
			
			var addButton = AJS.$('<button/>', {
				'class':'aui-button',
				'text':'Add'
			}).click(
				{
					nameInput:newStepNameInput,
					descArea:newStepDescArea,
					expectArea:newStepExpectArea,
					field:this
				},
				function(event){
					event.stopPropagation();
					event.preventDefault();
					event.stopImmediatePropagation();
					event.data.field.addStep(
							event.data.nameInput.val(),
							event.data.descArea.val(),
							event.data.expectArea.val()
						);
				}
			)
			
			inputStepTR.append(
				AJS.$('<td/>').append(newStepNameInput)
			);
			inputStepTR.append(
				AJS.$('<td/>').append(newStepDescArea)
			);
			inputStepTR.append(
				AJS.$('<td/>').append(newStepExpectArea)
			);
			inputStepTR.append(
				AJS.$('<td/>').append(addButton)
			);

			if(this.field && this.field.steps){
				for(var j=0; j<this.field.steps.length; j++){
					var step = this.field.steps[j];
					var stepTR = AJS.$('<tr/>',{'class':'synapse-sortable synapse-cf-edit-tc-steps-table-step-row'});
					stepTR.append(AJS.$('<td/>',{'text':this.field.steps.length-j}));
					
					var nameInput = AJS.$('<input/>', {'class':'text'}).css({'display':'none'}).val(step.name);
					var descArea = AJS.$('<textarea/>', {'class':'textarea', 'rows':'3'}).css({'display':'none'}).val(step.description);
					var expectArea = AJS.$('<textarea/>', {'class':'textarea','rows':'3'}).css({'display':'none'}).val(step.expected);
					
					var nameEl = AJS.$('<span/>',{'text':step.name, 'class':'synapse-cf-edit-tc-steps-table-row-editable'}).append(
						AJS.$('<span/>',{'text':'Edit', 'class':'aui-icon aui-icon-small aui-iconfont-edit'})
					);
					var descEl = AJS.$('<span/>',{'text':step.description, 'class':'synapse-cf-edit-tc-steps-table-row-editable'}).append(
						AJS.$('<span/>',{'text':'Edit', 'class':'aui-icon aui-icon-small aui-iconfont-edit'})
					);
					var expectEl = AJS.$('<span/>',{'text':step.expected, 'class':'synapse-cf-edit-tc-steps-table-row-editable'}).append(
						AJS.$('<span/>',{'text':'Edit', 'class':'aui-icon aui-icon-small aui-iconfont-edit'})
					);
					
					var removeButton = AJS.$('<button/>', {
						'class':'aui-button aui-button-subtle'
					}).append(
						AJS.$('<span/>',{
							'class':'aui-icon aui-icon-small aui-iconfont-remove',
							'text':'Remove'
						})
					).click(
						{
							step:step,
							stepTR:stepTR,
							field:this
						},
						function(event){
							event.stopPropagation();
							event.preventDefault();
							event.stopImmediatePropagation();
							event.data.field.removeStep(event.data.step);
							event.data.stepTR.remove();
						}
					)
					
					var saveButton = AJS.$('<button/>', {
						'class':'aui-button',
						'text':'Save'
					}).click(
						{
							field:this,
							step:step,
							table:table,
							nameInput:nameInput,
							descArea:descArea,
							expectArea:expectArea,
							nameEl:nameEl,
							descEl:descEl,
							expectEl:expectEl,
							removeBtn:removeButton
						},
						function(event){
							event.stopPropagation();
							event.preventDefault();
							event.stopImmediatePropagation();
							var updated = event.data.field.saveStep(
								event.data.step,
								event.data.nameInput.val(),
								event.data.descArea.val(),
								event.data.expectArea.val()
							);
							
							event.data.nameEl.text('');
							event.data.descEl.text('');
							event.data.expectEl.text('');
							event.data.nameEl.append(updated.name,
								AJS.$('<span/>',{'text':'Edit', 'class':'aui-icon aui-icon-small aui-iconfont-edit'})
							);
							event.data.descEl.append(updated.description,
								AJS.$('<span/>',{'text':'Edit', 'class':'aui-icon aui-icon-small aui-iconfont-edit'})
							);
							event.data.expectEl.append(updated.expected,
								AJS.$('<span/>',{'text':'Edit', 'class':'aui-icon aui-icon-small aui-iconfont-edit'})
							);
							event.data.nameEl.show();
							event.data.descEl.show();
							event.data.expectEl.show();
							event.data.removeBtn.show();
							
							event.data.nameInput.val(updated.name);
							event.data.descArea.val(updated.description);
							event.data.expectArea.val(updated.expected);
							event.data.nameInput.hide();
							event.data.descArea.hide();
							event.data.expectArea.hide();
							AJS.$(this).hide();
						}
					).css({'display':'none'});
					
					AJS.$.each([nameEl, descEl, expectEl], function(index, value){
	    				value.click({
	    						table:table,
								nameInput:nameInput,
								descArea:descArea,
								expectArea:expectArea,
								nameEl:nameEl,
								descEl:descEl,
								expectEl:expectEl,
								removeBtn:removeButton,
								saveBtn:saveButton
							},
	    					function(event){
	    						event.data.table.find('tbody:last');
								event.data.nameEl.hide();
								event.data.descEl.hide();
								event.data.expectEl.hide();
								event.data.nameInput.show();
								event.data.descArea.show();
								event.data.expectArea.show();
								event.data.removeBtn.hide();
								event.data.saveBtn.show();
	    					}
	    				);
					});
					
					stepTR.append(
						AJS.$('<td/>').append(nameInput,nameEl)
					);
					stepTR.append(
						AJS.$('<td/>').append(descArea,descEl)
					);
					stepTR.append(
						AJS.$('<td/>').append(expectArea,expectEl)
					);
					stepTR.append(AJS.$('<td/>').append(saveButton,removeButton));
					tbody.prepend(stepTR);
				}
			}
						tbody.append(inputStepTR);

			
		
			tbody.css({'overflow': 'auto'});

			table.append(tbody);
			var tbodySortable = table.find('tbody');
			var stepField = this;
			tbodySortable.sortable({
				axis:'y',
				items:'.synapse-sortable',
				helper: function(event, elt){
					var helper =  elt.clone(true).addClass('synapse-movable');
                    helper.children().each(function (i) {
                        AJS.$(this).width(elt.children().eq(i).width());
                    });
					return helper;
				},
			    start: function(event, ui) {
			        ui.placeholder.height(ui.item.height());
					AJS.$(this).attr('data-previndex', ui.item.index());
			    },
			    sort: function(event, ui) {
			    	//Uncomment to fix helper in Google Chrome and Safari      
			    	var ua = navigator.userAgent.toLowerCase();
					if ( ua.indexOf( "chrome" ) != -1 || ua.indexOf( "safari" ) != -1 ) {
						//browserName = "opera";
			        	ui.helper.css({'top' : ui.position.top + AJS.$(window).scrollTop() + 'px'});
					}
			    },
			    update: function(event, ui) {
			        // gets the new and old index then removes the temporary attribute
			        var newIndex = ui.item.index();
			        var oldIndex = AJS.$(this).attr('data-previndex');
			        AJS.$(this).removeAttr('data-previndex');
			        stepField.move(parseInt(oldIndex), parseInt(newIndex));
			    },
                containment: "document",
                cursor: "move",
                scroll: true
			});
		}
	}
} 