SynapseRTTestStepsView = function(tableId, fieldId, statesId, issueKey){
	this.srcFieldId = fieldId;
	this.srcStatesId = statesId;
	this.tableId = tableId;
	this.field = {'steps':[]};
	this.states = [];
	this.issueKey = issueKey;
	this.saveButton;
	
	this.setActual = function(step, actual){
		var pos = this.field.steps.indexOf(step);
		if(pos != -1){
			this.field.steps[pos].actual = actual;
		}
		this.saveButton.attr('aria-disabled', 'false');
		AJS.$('#'+this.srcFieldId).val(JSON.stringify(this.field));
	}
	
	
	this.setState = function(step, state){
		var pos = this.field.steps.indexOf(step);
		if(pos != -1){
			this.field.steps[pos].state = state;
		}
		this.saveButton.attr('aria-disabled', 'false');
		AJS.$('#'+this.srcFieldId).val(JSON.stringify(this.field));
	}
	
	this.init = function(){
		try{
			this.field = JSON.parse(AJS.$('#' + this.srcFieldId).val());
		}catch(ex){
			console.log(ex);
		}
		
		try{
			this.states = JSON.parse(AJS.$('#' + this.srcStatesId).val());
		}catch(ex){
			console.log(ex);
		}
		
		this.rebuild();
	}
	
	this.rebuild = function(){
		var table = AJS.$('#' + this.tableId);
		if(table && table.length && this.field && this.field.steps){
			table.empty();
			var thead = AJS.$('<thead/>');
			var tbody = AJS.$('<tbody/>');
			var headerTR = AJS.$('<tr/>');
			headerTR.append(AJS.$('<th/>',{'text':'#'}));
			headerTR.append(AJS.$('<th/>',{'text':'Name'}));
			headerTR.append(AJS.$('<th/>',{'text':'Description'}));
			headerTR.append(AJS.$('<th/>',{'text':'Expected results'}));
			headerTR.append(AJS.$('<th/>',{'text':'Actual results'}));
			headerTR.append(AJS.$('<th/>',{'text':'State'}));
			table.append(thead.append(headerTR));
			if(this.field.steps){
			for(var j=0; j<this.field.steps.length; j++){
				var step = this.field.steps[j];
				var stepTR = AJS.$('<tr/>',{'class':'synapse-sortable synapse-cf-edit-tc-steps-table-step-row'});
				stepTR.append(AJS.$('<td/>',{'text':this.field.steps.length-j}));
				
				var nameEl = AJS.$('<span/>',{'text':step.name});
				var descEl = AJS.$('<span/>',{'text':step.description});
				var expectEl = AJS.$('<span/>',{'text':step.expected});
				var actualArea = AJS.$('<textarea/>', {'class':'textarea','rows':'3'}).val(step.actual);
				
				actualArea.data('oldVal', step.actual);
				actualArea.data('field', this);
				actualArea.data('step', step);
				
				// Look for changes in the value
				actualArea.bind("propertychange keyup input paste", function(event){
					var area = AJS.$(this);
				    if (area.data('oldVal') != area.val()) {
				        // Updated stored value
				        area.data('oldVal', area.val());
				        area.data('field').setActual(area.data('step'), area.val());
				    }
				});
				
				var stateSelectBtn = AJS.$('<button/>', {
					'class':'aui-button aui-dropdown2-trigger aui-button-subtle',
					'aria-owns':'dropdown2-more-'+this.tableId+'-'+j,
					'aria-haspopup':'true',
					'text':'No execution'
				});
				var dropdownDiv = AJS.$('<div/>',{
					'id':'dropdown2-more-'+this.tableId+'-'+j,
					'class':'aui-dropdown2 aui-style-default'
				});
				var dropdownUl = AJS.$('<ul/>',{
					'class':'aui-list-truncate'
				});
				dropdownUl.append(
					AJS.$('<li/>').append(
						AJS.$('<a/>',{
							'href':'javascript:void(0);',
							'value':'',
							'text':'No execution'
						}).click(
							{
								field:this,
								step:step,
								btn:stateSelectBtn
							},
							function(event){
								event.data.field.setState(event.data.step, AJS.$(this).attr('value'));
								event.data.btn.text(AJS.$(this).text());
							}
						)
					)
				);
				if(this.states){
					for(var s=0; s<this.states.length; s++){
						if(this.states[s].key==step.state)
							stateSelectBtn.text(this.states[s].value);
						dropdownUl.append(
							AJS.$('<li/>').append(
								AJS.$('<a/>',{
									'href':'javascript:void(0);',
									'value':this.states[s].key,
									'text':this.states[s].value
								}).click(
									{
										field:this,
										step:step,
										btn:stateSelectBtn
									},
									function(event){
										event.data.field.setState(event.data.step, AJS.$(this).attr('value'));
										event.data.btn.text(AJS.$(this).text());
									}
								)
							)
						);
					}
					dropdownDiv.append(dropdownUl);
				}
				
				stepTR.append(
					AJS.$('<td/>').append(nameEl)
				);
				stepTR.append(
					AJS.$('<td/>').append(descEl)
				);
				stepTR.append(
					AJS.$('<td/>').append(expectEl)
				);
				stepTR.append(
					AJS.$('<td/>').append(actualArea)
				);
				stepTR.append(
					AJS.$('<td/>').append(stateSelectBtn, dropdownDiv)
				);
				tbody.prepend(stepTR);
			}
									}
			var footerTR = AJS.$('<tr/>');
			
			this.saveButton = AJS.$('<button/>', {
				'class':'aui-button aui-button-primary',
				'aria-disabled':'true'
			}).append(
				AJS.$('<span/>',{
					'class':'aui-icon aui-icon-small aui-iconfont-approve',
					'text':'Save'
				}),
				' Save'
			).click(
				{
					field:this
				},
				function(event){
					event.stopPropagation();
					event.preventDefault();
					event.stopImmediatePropagation();
					event.data.field.saveSteps();
				}
			)
			footerTR.append(
				AJS.$('<td/>', {'colspan':5})
			);
			
			footerTR.append(
				AJS.$('<td/>').append(this.saveButton)
			);
			tbody.append(footerTR);
			
				
			table.append(tbody);
		}
	}
	
	this.saveSteps = function(){
		var data = 'issueKey='+this.issueKey+'&fieldValue=' + JSON.stringify(this.field);
        console.log('save steps: ' + data);
        var saveButton = this.saveButton;
        AJS.$.ajax({
            url: AJS.contextPath() + '/plugins/servlet/testStepsServlet',
            async: true,
            type: 'POST',
            data: data,
            panel: this,
            success: function(result) {
            	console.log('got result: ' + result);
                var obj = JSON.parse(result);

                if (obj.errors) {
                    var tcErrorMsg = AJS.$('#stepsErrorMsg')
                    if(obj.errors.length > 0) {
                        for(var i = 0; i < obj.errors.length; i++) {
                            tcErrorMsg.append(AJS.$('<p/>').text(obj.errors[i]));
                        }

                        tcErrorMsg.show();
                    } else {
                        tcErrorMsg.hide();
                    }
                }
				saveButton.attr('aria-disabled', 'true');
				location.reload();
            }
        });
	}
} 